#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "fe.h"
#include "backend.h"
#include "main.h"

void
on_file_open_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    fileselection = create_fileselection();
    gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(fileselection));
    gtk_file_selection_complete(GTK_FILE_SELECTION(fileselection), "*.ici");
    gtk_widget_show(fileselection);
    gtk_main();
    if (selected_filename != NULL)
	file_open(selected_filename);
}


int
on_file_exit_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    return quit();
}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_clear1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_properties1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}



void
on_settings_preferences_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_help_about_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    about = create_about();
    gtk_widget_show(about);
    gtk_main();
}


void
about_okay_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
    gtk_widget_destroy(about);
    gtk_main_quit();
}


void
fileselection_ok_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
    char	*s;

    gtk_widget_hide(fileselection);
    if (selected_filename != NULL)
    {
	free(selected_filename);
	selected_filename = NULL;
    }
    s = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselection));
    if ((selected_filename = malloc(strlen(s) + 1)) != NULL)
	strcpy(selected_filename, s);
    gtk_widget_destroy(fileselection);
    fileselection = NULL;
    gtk_main_quit();
}


void
fileselection_cancel_button_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
    gtk_widget_hide(fileselection);
    if (selected_filename != NULL)
    {
	free(selected_filename);
	selected_filename = NULL;
    }
    gtk_widget_destroy(fileselection);
    fileselection = NULL;
    gtk_main_quit();
}

void
on_set_clear_breakpoint_activate      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    gtk_menu_popdown(GTK_MENU(popup));
    gtk_main_quit();
}


void
on_run_to_here_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    gtk_menu_popdown(GTK_MENU(popup));
    gtk_main_quit();
}

gboolean
on_text_button_press_event             (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
    GtkWidget	*text;

    if (event->button == 3)
    {
	if (popup == NULL)
	    popup = create_popup_menu();
	text = fwidget(window, "text");
	gtk_menu_popup
	(
	    GTK_MENU(popup),
	    NULL,
	    NULL,
	    NULL,
	    NULL,
	    event->button,
	    event->time
	);
	gtk_main();
	return TRUE;
    }
    return FALSE;
}

void
on_popup_menu_cancel                   (GtkMenuShell    *menushell,
                                        gpointer         user_data)
{
    gtk_main_quit();
}


void
on_ctree_popup_up_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    gtk_main_quit();
}


void
on_list_popup_up_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    gtk_main_quit();
}


void
on_list_popup_deactivate               (GtkMenuShell    *menushell,
                                        gpointer         user_data)
{
    gtk_main_quit();
}


void
on_list_popup_down_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_cont_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
    if (backend == NULL)
    {
	restart_program();
    }
    else
    {
	switch (backend->state)
	{
	case Finished:
	    ask_restart_program();
	    break;

	case Stopped:
	    Backend_continue(backend);
	    break;
	}
    }
}

void
on_step_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
    switch (backend->state)
    {
    case Finished:
	ask_restart_program();
	break;

    case Stopped:
	Backend_step(backend);
	break;
    }
}


void
on_step_over_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
    switch (backend->state)
    {
    case Finished:
	ask_restart_program();
	break;

    case Stopped:
	Backend_next(backend);
	break;
    }
}


void
on_step_out_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
    switch (backend->state)
    {
    case Finished:
	ask_restart_program();
	break;

    case Stopped:
	Backend_finish(backend);
	break;
    }
}


void
on_interrupt_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
    Backend_interrupt(backend);
}

void
on_clist_click_column                  (GtkCList        *clist,
                                        gint             column,
                                        gpointer         user_data)
{
    if (column == 0)
	scope_view_up();
    else if (column == 1)
	scope_view_down();
}


void
on_clist_select_row                    (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

}
