#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "dialog.h"

GtkWidget*
make_dialog(int nbuttons)
{
  GtkWidget *dialog;
  GtkWidget *vbox;
  GtkWidget *frame;
  GtkWidget *label;
  GtkWidget *hbuttonbox;
  GtkWidget *button1;
  GtkWidget *button2;

  dialog = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_widget_set_name (dialog, "dialog");
  gtk_object_set_data (GTK_OBJECT (dialog), "dialog", dialog);
  gtk_window_set_title (GTK_WINDOW (dialog), "Warning");
  gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
  gtk_window_set_policy (GTK_WINDOW (dialog), TRUE, TRUE, TRUE);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox, "vbox");
  gtk_widget_ref (vbox);
  gtk_object_set_data_full (GTK_OBJECT (dialog), "vbox", vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (dialog), vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 4);

  frame = gtk_frame_new ("Dialog");
  gtk_widget_set_name (frame, "frame");
  gtk_widget_ref (frame);
  gtk_object_set_data_full (GTK_OBJECT (dialog), "frame", frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 5);
  gtk_frame_set_label_align (GTK_FRAME (frame), 0.01, 0.5);

  label = gtk_label_new ("This is the text of the dialog. It should explain just what is going on and exactly what needs attention. You should really be able to build it up as needed for sprintf etc...");
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (dialog), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_container_add (GTK_CONTAINER (frame), label);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_FILL);
  gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label), 0.1, 0.05);
  gtk_misc_set_padding (GTK_MISC (label), 10, 10);

  hbuttonbox = gtk_hbutton_box_new ();
  gtk_widget_set_name (hbuttonbox, "hbuttonbox");
  gtk_widget_ref (hbuttonbox);
  gtk_object_set_data_full (GTK_OBJECT (dialog), "hbuttonbox", hbuttonbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox);
  gtk_box_pack_start (GTK_BOX (vbox), hbuttonbox, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox), 20);
  gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (hbuttonbox), 0, 0);

  button1 = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_set_name (button1, "button1");
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (dialog), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_container_add (GTK_CONTAINER (hbuttonbox), button1);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  if (nbuttons > 1)
  {
      button2 = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
      gtk_widget_set_name (button2, "button2");
      gtk_widget_ref (button2);
      gtk_object_set_data_full (GTK_OBJECT (dialog), "button2", button2,
	  			(GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (button2);
      gtk_container_add (GTK_CONTAINER (hbuttonbox), button2);
      GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);
  }

  return dialog;
}
