/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "interface.h"
#include "support.h"
#include "fe.h"
#include "backend.h"
#include "main.h"

GtkWidget	*window;
GtkWidget	*dialog;
GtkWidget	*about;
GtkWidget	*fileselection;
GtkWidget	*popup;
GtkWidget	*ctree_popup;
GtkWidget	*list_popup;
char		*selected_filename = NULL;
guint		idle_id;
Backend		*backend;

void		init(void);

int
main(int argc, char *argv[])
{

#ifdef ENABLE_NLS
    bindtextdomain(PACKAGE, PACKAGE_LOCALE_DIR);
    textdomain(PACKAGE);
#endif

    gnome_init("fe", VERSION, argc, argv);

    remember_args(&argv[1]);

    /*
     * The following code was added by Glade to create one of each component
     * (except popup menus), just so that you see something after building
     * the project. Delete any components that you don't want shown initially.
     */
    window = create_window();
    gtk_signal_connect(GTK_OBJECT(window), "delete-event", GTK_SIGNAL_FUNC(quit), NULL);
    gtk_widget_show(window);
    idle_id = gtk_idle_add((GtkFunction)init, NULL);
    gtk_main();
    return 0;
}

void
init(void)
{
    gtk_idle_remove(idle_id);
    if (get_remembered_args() != NULL)
	restart_program();
}

int
quit(void)
{
    if (backend != NULL && (backend->state != Finished && backend->state != Broken))
    {
	do_dialog
	(
	    2,
	    "Really Exit?",
	    "The program is still running. Do you really want to quit?"
	);
	if (!get_dialog_state())
	    return 0;
    }
    gtk_main_quit();
    return 1;
}

GtkWidget *
fwidget(GtkWidget *w, const char *name)
{
    if (w->parent)
	w = gtk_widget_get_toplevel(w);
    return (GtkWidget *)gtk_object_get_data(GTK_OBJECT(w), name);
}
